import unittest
import pytest
import podminka

class MyTestCase(unittest.TestCase):

    # Testy pro mocnění
    def test_basicPower1(self):
        x1, x2, result, isPower = 3, 4, 81, True
        if isPower is True:
            operation = "mocnění"
        else:
            operation = "odmocňování"

        self.assertEqual(podminka.exponentiation(x1,x2,isPower), result, "Operace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(podminka.exponentiation(x1,x2,isPower)))
    def test_basicPower2(self):
        x1, x2, result, isPower = 5, 3, 125, True
        if isPower is True:
            operation = "mocnění"
        else:
            operation = "odmocňování"

        self.assertEqual(podminka.exponentiation(x1,x2,isPower), result, "Operace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(podminka.exponentiation(x1,x2,isPower)))
    def test_basicPower3(self):
        x1, x2, result, isPower = 100, 0, 1, True
        if isPower is True:
            operation = "mocnění"
        else:
            operation = "odmocňování"

        self.assertEqual(podminka.exponentiation(x1,x2,isPower), result, "Operace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(podminka.exponentiation(x1,x2,isPower)))
    def test_basicPowerFloat1(self):
        x1, x2, result, isPower = 2, 2.5, 5.656854249492381, True
        if isPower is True:
            operation = "mocnění"
        else:
            operation = "odmocňování"

        self.assertEqual(podminka.exponentiation(x1,x2,isPower), result, "Operace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(podminka.exponentiation(x1,x2,isPower)))
    def test_basicPowerFloat2(self):
        x1, x2, result, isPower = 2.5, 2, 6.25, True
        if isPower is True:
            operation = "mocnění"
        else:
            operation = "odmocňování"

        self.assertEqual(podminka.exponentiation(x1,x2,isPower), result, "Operace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(podminka.exponentiation(x1,x2,isPower)))

    def test_basicPowerBigNumber(self):
        x1, x2, result, isPower = 75, 30, 178582090170014730345915410225643427111208438873291015625, True
        if isPower is True:
            operation = "mocnění"
        else:
            operation = "odmocňování"

        self.assertEqual(podminka.exponentiation(x1,x2,isPower), result, "Operace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(podminka.exponentiation(x1,x2,isPower)))
    def test_basicPowerMinusAt0(self):
        x1, x2, result, isPower = -2, 0, 1, True
        if isPower is True:
            operation = "mocnění"
        else:
            operation = "odmocňování"

        self.assertEqual(podminka.exponentiation(x1,x2,isPower), result, "Operace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(podminka.exponentiation(x1,x2,isPower)))
    def test_basicPowerMinusAtEven(self):
        x1, x2, result, isPower = -5, 4, 625, True
        if isPower is True:
            operation = "mocnění"
        else:
            operation = "odmocňování"

        self.assertEqual(podminka.exponentiation(x1,x2,isPower), result, "Operace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(podminka.exponentiation(x1,x2,isPower)))
    def test_basicPowerMinusAtOdd(self):
        x1, x2, result, isPower = -5, 5, -3125, True
        if isPower is True:
            operation = "mocnění"
        else:
            operation = "odmocňování"

        self.assertEqual(podminka.exponentiation(x1,x2,isPower), result, "Operace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(podminka.exponentiation(x1,x2,isPower)))

    def test_basicPower00(self):
        x1, x2, result, isPower = 0, 0, None, True
        print("Pokud vám neprošel 'test_basicPower00', nebyla při 'x1 = 0', 'x2 = 0' a 'isPower = True' vyvolána výjimka ValueError pro neurčitý výraz!")
        self.assertRaises(ValueError,lambda: podminka.exponentiation(x1,x2, isPower))

    # Testy pro odmocňování
    def test_basicSqrtBasic1(self):
        x1, x2, result, isPower = 9, 2, 3, False
        if isPower is True:
            operation = "mocnění"
        else:
            operation = "odmocňování"

        self.assertEqual(podminka.exponentiation(x1,x2,isPower), result, "Operace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(podminka.exponentiation(x1,x2,isPower)))
    def test_basicSqrtBasic2(self):
        x1, x2, result, isPower = 8, 3, 2, False
        if isPower is True:
            operation = "mocnění"
        else:
            operation = "odmocňování"

        self.assertEqual(podminka.exponentiation(x1,x2,isPower), result, "Operace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(podminka.exponentiation(x1,x2,isPower)))
    def test_basicSqrtBasic3(self):
        x1, x2, result, isPower = 456976, 4, 26, False
        if isPower is True:
            operation = "mocnění"
        else:
            operation = "odmocňování"

        self.assertEqual(podminka.exponentiation(x1,x2,isPower), result, "Operace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(podminka.exponentiation(x1,x2,isPower)))
    def test_basicSqrtFloat1(self):
        x1, x2, result, isPower = 7, 3, 1.912931182772389, False
        if isPower is True:
            operation = "mocnění"
        else:
            operation = "odmocňování"

        self.assertEqual(podminka.exponentiation(x1,x2,isPower), result, "Operace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(podminka.exponentiation(x1,x2,isPower)))
    def test_basicSqrtFloat2(self):
        x1, x2, result, isPower = 15, 2, 3.872983346207417, False
        if isPower is True:
            operation = "mocnění"
        else:
            operation = "odmocňování"

        self.assertEqual(podminka.exponentiation(x1,x2,isPower), result, "Operace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(podminka.exponentiation(x1,x2,isPower)))
    def test_basicSqrtAt1(self):
        x1, x2, result, isPower = 55, 1, 55, False
        if isPower is True:
            operation = "mocnění"
        else:
            operation = "odmocňování"

        self.assertEqual(podminka.exponentiation(x1,x2,isPower), result, "Operace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(podminka.exponentiation(x1,x2,isPower)))
    def test_basicSqrtAt0(self):
        x1, x2, result, isPower = 55, 0, 55, False
        print("Pokud vám neprošel 'test_basicSqrtAt0', nebyla při 'x2 = 0' a 'isPower = False' vyvolána výjimka ValueError pro neurčitý výraz!")

        self.assertRaises(ValueError,lambda: podminka.exponentiation(x1,x2, isPower))

    def test_basicSqrtAtMinus(self):
        x1, x2, result, isPower = 15, -2, 15, False
        print("Pokud vám neprošel 'test_basicSqrtAtMinus', nebyla při 'x2 = -2' a 'isPower = False' vyvolána výjimka ValueError pro neurčitý výraz!")

        self.assertRaises(ValueError,lambda: podminka.exponentiation(x1,x2, isPower))

    def test_basicSqrtFromMinus(self):
        x1, x2, result, isPower = -8, 3, 2, False
        print("Pokud vám neprošel 'test_basicSqrtFromMinus', nebyla při 'x1 = -8' a 'isPower = False' vyvolána výjimka ValueError pro neurčitý výraz!")

        self.assertRaises(ValueError,lambda: podminka.exponentiation(x1,x2, isPower))

    def test_basicSqrtComputingProblem(self):
        x1, x2, result, isPower = 4913, 3, 17, False
        if isPower is True:
            operation = "mocnění"
        else:
            operation = "odmocňování"

        self.assertEqual(podminka.exponentiation(x1,x2,isPower), result, "Operace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(podminka.exponentiation(x1,x2,isPower)))



if __name__ == '__main__':
    unittest.main()

